#! /bin/sh
#
#                                                                               
# This software is subject to the terms of the IBM Public License               
# You must accept the terms of this license to use this software.               
#                                                                               
# Copyright (C) 2000, International Business Machines Corporation               
# and others.  All Rights Reserved.                                             
#                                                                               
# Further information about IBM Public License Version 1.0 is obtained from     
# url http://oss.software.ibm.com/developer/opensource/license10.html           
#                                                        
# UTF-8 Locale Generation Utility
#
#
#
# Contributed by Yoshito Kawada, IBM
# Updated by Kentaroh Noji, IBM (formating + add display locale list )
#

LOCALEDEF=`which localedef`

if [ $? -ne 0 ]; then 
 echo "localedef is not installed.  You have to instal Glibc2.1.9x or above"
 exit 1
fi

CHARMAPDIR=/cmap
UTF8CHARMAP=charmap.utf8
OPT=-c
LOCALESRCDIR=./src/locale

README=./doc/ReadMe.txt

displaychoice( ){

  echo " ====================== UTF-8 Locale Generation Utility ======================="
  echo 
  echo " # This software is subject to the terms of the IBM Public License.           #"               
  echo " # You must accept the terms of this license to use this software.            #"               
  echo " #                                                                            #"                             
  echo " # Copyright (C) 2000, International Business Machines Corporation            #"               
  echo " # and others.  All Rights Reserved.                                          #"       
  echo " #                                                                            #"
  echo " # NOTE: You have to use Glibc2.1.9x or above. Your glibc                     #"
  echo ' #       version can be checked by "rpm -qv glibc"                            #'
  echo
            
  echo " ---------------------------------  MENU  -------------------------------------"
  echo 
  echo " 1) Create all locales                                     "  
  echo " 2) Specify the locale to create                           "
  echo " 3) Display Locale list and specify the locale             "                 
  echo " 4) Display Readme                                         "
  echo " 5) Exit                                                   "
  echo
  echo -n  "Select menu item => "           
}




action( ) {

read ANSWER

case $ANSWER in
     1) 
       echo "This can take more than 20 minutes. Are you ready to start? [Yes/No]"
       read ANSWER
       case ${ANSWER} in 
           [yY]*)

                   cd ${LOCALESRCDIR}
                    for i in [!L]*     # exclude LC_hoge files 
                     do
            echo "${LOCALEDEF} -i $i -f ..${CHARMAPDIR}/${UTF8CHARMAP} ${OPT} $i.utf8"
                  ${LOCALEDEF} -i $i -f ..${CHARMAPDIR}/${UTF8CHARMAP} ${OPT} $i.utf8
                    done 
                ;;
            *) 
              $0  ;;

         esac                            
                                   ;;

     2)  
       echo -n "Specify the name of locales (e.g.  en_BE fr_BE nl_BE) => "
       cd ${LOCALESRCDIR}  
       read ANSWER
       echo "This takes like 20 seconds for each."
       for i in ${ANSWER}
        do
       echo "${LOCALEDEF} -i $i -f ..${CHARMAPDIR}/${UTF8CHARMAP} ${OPT} $i.utf8"

       ${LOCALEDEF} -i $i -f ..${CHARMAPDIR}/${UTF8CHARMAP} ${OPT} $i.utf8
       cd ../..

        done                         ;;

 

      3) 
         cd  ${LOCALESRCDIR}
         clear
         echo
         ls [!L]*
         cd ../..
         echo  
         echo -n "Specify the name of locales (e.g. en_BE fr_BE nl_BE) => "
         cd ${LOCALESRCDIR}  
         read ANSWER
         echo "This takes like 20 seconds for each."
         for i in ${ANSWER}
          do
#           test find ./ $i
           echo "${LOCALEDEF} -i $i -f ..${CHARMAPDIR}/${UTF8CHARMAP} ${OPT} $i.utf8"

           ${LOCALEDEF} -i $i -f ..${CHARMAPDIR}/${UTF8CHARMAP} ${OPT} $i.utf8

         done                         ;;
 

     4) 
          if [ -f ./${README} ]; then           
           less ./${README}
           clear
          else
            echo "${README} does not exist"          
            exit 1

        fi           ;;
  


      5)
        exit 0  ;;

      q)
        exit 0;;


 
esac
}

# clear
# displaychoice
# action

while true
 do
 clear
 displaychoice
 action
 echo -n "Compleated... "
 read ANSWER
done

 
